package com.example.versionreturning;

import com.example.versionreturning.domain.CreateCounterCmd;
import com.example.versionreturning.domain.IncreaseCounterCmd;
import org.axonframework.commandhandling.VersionedAggregateIdentifier;
import org.axonframework.commandhandling.gateway.CommandGateway;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import java.util.UUID;

@SpringBootApplication
public class VersionreturningApplication {

    @Autowired
    CommandGateway commandGateway;

	public static void main(String[] args) {
		SpringApplication.run(VersionreturningApplication.class, args).getBean(VersionreturningApplication.class).run();
	}

	public void run() {
	    VersionedAggregateIdentifier versionedId = commandGateway.sendAndWait(new CreateCounterCmd());

	    UUID id = UUID.fromString(versionedId.getIdentifier());
	    long version = versionedId.getVersion();

	    System.out.println(id + " " + version);
	    version = commandGateway.sendAndWait(new IncreaseCounterCmd(id, version));
        System.out.println(version);
        version = commandGateway.sendAndWait(new IncreaseCounterCmd(id, version));
        System.out.println(version);
        version = commandGateway.sendAndWait(new IncreaseCounterCmd(id, version));
	    System.out.println(version);

    }

}
