package com.example.versionreturning.infra;

import org.axonframework.config.AggregateConfigurer;
import org.axonframework.config.ModuleConfiguration;
import org.axonframework.spring.config.AxonConfiguration;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;

import java.util.List;

/**
 * Configuration to modify the default Axon aggregate configuration to use our VersionReturningAggregateAnnotationCommandHandler
 * instead of the default AggregateAnnotationCommandHandler
 */
@Configuration
public class AxonConfig {

    @Autowired
    public void configure(AxonConfiguration configuration) {
        for(ModuleConfiguration module : configuration.getModules()) {
            if(module instanceof AggregateConfigurer<?>) {
                AggregateConfigurer<?> aggregateConfigurer = (AggregateConfigurer<?>)module;
                aggregateConfigurer.configureCommandHandler(c -> new VersionReturningAggregateAnnotationCommandHandler(
                        aggregateConfigurer.aggregateType(), aggregateConfigurer.repository()));
            }
        }
    }

}
